
module Main
  ( main
  ) where

import Test.Hspec
import Test.QuickCheck

import Codec.Dvorak

main :: IO ()
main = hspec $ do
  describe "Codec.Dvorak" $ do

    it "correctly ciphers the keyboard" $ do
      toDvorak "][abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ;',./_+{}:\"<>?=-"
        `shouldBe` "=/axje.uidchtnmbrl'poygk,qf;AXJE>UIDCHTNMBRL\"POYGK<QF:s-wvz{}?+S_WVZ]["

    it "is reversible" $
      property $ \s -> s == (fromDvorak . toDvorak) s
